''' 
    Title: gg_scoreboard
    Version: 1.7.1
    Description: Shows gungame level on scoreboard.
'''
# ==============================================================================
#   IMPORTS
# ==============================================================================
# Python imports
import gamethread

# EventScripts imports
import es

# GunGame imports
import gungamelib

# ==============================================================================
#   ADDON REGISTRATION
# ==============================================================================
# Register this addon with EventScripts
info = es.AddonInfo()
info.name     = 'Scoreboard Addon for GunGame5'
info.version  = '1.7.1'
info.url      = ''
info.basename = 'gungame/custom_addons/gg_scoreboard'
info.author   = 'addem1234 (help from PitBull0993)'

# ==============================================================================
#  GLOBALS
# ==============================================================================

msg = gungamelib.getVariableValue('gg_scoreboard_msg')
winleet = gungamelib.getVariableValue('gg_scoreboard_winleet')
useest = gungamelib.getVariableValue('gg_scoreboard_useest')

# ==============================================================================
#   GAME EVENTS
# ==============================================================================
def load():
	gg_scoreboard = gungamelib.registerAddon('gg_scoreboard')
	gg_scoreboard.setDisplayName('GG Scoreboard')
	if msg:
		gg_scoreboard.loadTranslationFile()

def unload():
	gungamelib.unregisterAddon('gg_scoreboard')
	
def player_spawn(event_var):
	userid = event_var['userid']
	if not es.exists('userid', userid):
		return
	setkills(userid, None, 1)
	if msg:
		gungamelib.msg('gg_scoreboard', userid, 'ScoreBoardMsg')
	
def player_death(event_var):
	if not es.exists('userid', event_var['userid']):
		return
	if event_var['attacker'] == 0:
		return
	setkills(event_var['userid'], None, 1)
	setkills(event_var['attacker'], None, 1)
	
def gg_leveldown(event_var):
	setkills(event_var['userid'], None, 1)
	
def gg_levelup(event_var):
	setkills(event_var['userid'], None, 1)
	
def gg_win(event_var):
	if winleet != 0:
		setkills(event_var['winner'], winleet, 2)

# ==============================================================================
#   HELPER FUNCTIONS
# ==============================================================================
def setkills(userid, level=None, again=None):
	if not es.exists('userid', userid):
		return
	if gungamelib.getGlobal('isWarmup'):
		return
	
	if level == None:
		level = gungamelib.getPlayer(userid)['level']
	
	if useest == 0:
		es.server.queuecmd('score set %s %s' % (userid, level))
	else:
		es.server.queuecmd('est_killset %s %s' % (userid, level))
		
	if again == 1:
		gamethread.delayed(0.1, setkills,(userid))
		
	if again == 2:
		gamethread.delayed(0.1, setkills,(userid, level))
		gamethread.delayed(1, setkills,(userid, level))